---
title: Location
slug: Web/API/Location
tags:
  - API
  - HTML DOM
  - Interface
  - Location
  - Reference
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>Location</code></strong> interface represents the location (URL) of the object it is linked to. Changes done on it are reflected on the object it relates to. Both the {{domxref("Document")}} and {{domxref("Window")}} interface have such a linked <code>Location</code>, accessible via {{domxref("Document.location")}} and {{domxref("Window.location")}} respectively.</p>

<h2 id="Anatomy_Of_Location">Anatomy Of Location</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;span id="href" title="href"&gt;&lt;span id="origin" title="origin"&gt;&lt;span id="protocol" title="protocol"&gt;http:&lt;/span&gt;//&lt;span id="host" title="host"&gt;&lt;span id="hostname" title="hostname"&gt;example.org&lt;/span&gt;:&lt;span id="port" title="port"&gt;8888&lt;/span&gt;&lt;/span&gt;&lt;/span&gt;&lt;span id="pathname" title="pathname"&gt;/foo/bar&lt;/span&gt;&lt;span id="search" title="search"&gt;?q=baz&lt;/span&gt;&lt;span id="hash" title="hash"&gt;#bang&lt;/span&gt;&lt;/span&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">html, body {height:100%;}
html {display:table; width:100%;}
body {display:table-cell; text-align:center; vertical-align:middle; font-family:georgia; font-size:230%; line-height:1em; white-space:nowrap;}

[title] {position:relative; display:inline-block; box-sizing:border-box; /*border-bottom:.5em solid;*/ line-height:2em; cursor:pointer;}

[title]:before {content:attr(title); font-family:monospace; position:absolute; top:100%; width:100%; left:50%; margin-left:-50%; font-size:40%; line-height:1.5; background:black;}
[title]:hover:before,
:target:before {background:black; color:yellow;}

[title] [title]:before {margin-top:1.5em;}
[title] [title] [title]:before {margin-top:3em;}
[title] [title] [title] [title]:before {margin-top:4.5em;}

[title]:hover,
:target {position:relative; z-index:1; outline:50em solid rgba(255,255,255,.8);}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">[].forEach.call(document.querySelectorAll('[title][id]'), function (node) {
  node.addEventListener("click", function(e) {
    e.preventDefault();
    e.stopPropagation();
    window.location.hash = '#' + e.target.getAttribute('id');
  });
});
[].forEach.call(document.querySelectorAll('[title]:not([id])'), function (node) {
  node.addEventListener("click", function(e) {
    e.preventDefault();
    e.stopPropagation();
    window.location.hash = '';
  });
});</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Anatomy_Of_Location')}}</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("Location.ancestorOrigins")}}</dt>
 <dd>Is a static {{domxref("DOMStringList")}} containing, in reverse order, the origins of all ancestor browsing contexts of the document associated with the given <code>Location</code> object.</dd>
 <dt>{{domxref("Location.href")}}</dt>
 <dd>Is a stringifier that returns a {{domxref("USVString")}} containing the entire URL. If changed, the associated document navigates to the new page. It can be set from a different origin than the associated document.</dd>
 <dt>{{domxref("Location.protocol")}}</dt>
 <dd>Is a {{domxref("USVString")}} containing the protocol scheme of the URL, including the final <code>':'</code>.</dd>
 <dt>{{domxref("Location.host")}}</dt>
 <dd>Is a {{domxref("USVString")}} containing the host, that is the <em>hostname</em>, a <code>':'</code>, and the <em>port</em> of the URL.</dd>
 <dt>{{domxref("Location.hostname")}}</dt>
 <dd>Is a {{domxref("USVString")}} containing the domain of the URL.</dd>
 <dt>{{domxref("Location.port")}}</dt>
 <dd>Is a {{domxref("USVString")}} containing the port number of the URL.</dd>
 <dt>{{domxref("Location.pathname")}}</dt>
 <dd>Is a {{domxref("USVString")}} containing an initial <code>'/'</code> followed by the path of the URL, not including the query string or fragment.</dd>
 <dt>{{domxref("Location.search")}}</dt>
 <dd>Is a {{domxref("USVString")}} containing a <code>'?'</code> followed by the parameters or "querystring" of the URL. Modern browsers provide <a href="/en-US/docs/Web/API/URLSearchParams/get#Example">URLSearchParams</a> and <a href="/en-US/docs/Web/API/URL/searchParams#Example">URL.searchParams</a> to make it easy to parse out the parameters from the querystring.</dd>
 <dt>{{domxref("Location.hash")}}</dt>
 <dd>Is a {{domxref("USVString")}} containing a <code>'#'</code> followed by the fragment identifier of the URL.</dd>
 <dt>{{domxref("Location.origin")}} {{readOnlyInline}}</dt>
 <dd>Returns a {{domxref("USVString")}} containing the canonical form of the origin of the specific location.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("Location.assign()")}}</dt>
 <dd>Loads the resource at the URL provided in parameter.</dd>
 <dt>{{domxref("Location.reload()")}}</dt>
 <dd>Reloads the current URL, like the Refresh button.</dd>
 <dt>{{domxref("Location.replace()")}}</dt>
 <dd>Replaces the current resource with the one at the provided URL (redirects to the provided URL). The difference from the <code>assign()</code> method and setting the <code>href</code> property is that after using <code>replace()</code> the current page will not be saved in session {{domxref("History")}}, meaning the user won't be able to use the <em>back</em> button to navigate to it.</dd>
 <dt>{{domxref("Location.toString()")}}</dt>
 <dd>Returns a {{domxref("USVString")}} containing the whole URL. It is a synonym for {{domxref("HTMLHyperlinkElementUtils.href")}}, though it can't be used to modify the value.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">// Create anchor element and use href property for the purpose of this example
// A more correct alternative is to browse to the URL and use document.location or window.location
var url = document.createElement('a');
url.href = 'https://developer.mozilla.org:8080/en-US/search?q=URL#search-results-close-container';
console.log(url.href);      // https://developer.mozilla.org:8080/en-US/search?q=URL#search-results-close-container
console.log(url.protocol);  // https:
console.log(url.host);      // developer.mozilla.org:8080
console.log(url.hostname);  // developer.mozilla.org
console.log(url.port);      // 8080
console.log(url.pathname);  // /en-US/search
console.log(url.search);    // ?q=URL
console.log(url.hash);      // #search-results-close-container
console.log(url.origin);    // https://developer.mozilla.org:8080
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "browsers.html#the-location-interface", "Location")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Location")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Two methods creating such an object: {{domxref("Window.location")}} and {{domxref("Document.location")}}.</li>
 <li>URL related interfaces: {{domxref("URL")}}, {{domxref("URLSearchParams")}} and {{domxref("HTMLHyperlinkElementUtils")}}</li>
</ul>
